/**
*appmanager App
* Implementing an App to manage application App.
*/
var AppManagerApp = AppManagerApp || {};  //Define App Manager App namespace.
/**
*Constructor UNAS App
*/
AppManagerApp.App = function () {
    this.id = 'App Manager';
    this.name = 'App Manager';
    this.version = '6.0.62';
    this.active = false;
    this.menuIcon = '/apps/appmanager/images/logo.png?v=6.0.62&';
    this.shortcutIcon = '/apps/appmanager/images/logo.png?v=6.0.62&';
    //this.entryHelpUrl = '/apps/appmanager/appmanager_help.html?v=6.0.62&';
    var self = this;
    this.AppManagerAppWindow = function () { //create app window
        self.window=new MUI.Window({
            id: 'AppManagerAppWindow',
            title: UNAS._('App Manager'),
            icon: '/apps/appmanager/images/logo_small.png?v=6.0.62&',
            width: 1082,
            height: 650,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            //resizeLimit: { 'x': [200, 1200], 'y': [100, 1500] },
            loadMethod: 'xhr',
            contentURL: '/apps/appmanager/appmanager.html?v=6.0.62&',
            onClose:function(){
                if(window.appmanager && window.appmanager.onClose){
                    window.appmanager.onClose();
                    window.appmanager.onClose = null;
                }
            }
        });
    };
    this.AppManagerUninstall = function (){
        UNAS.RemoveDesktopShortcut('App Manager');
        UNAS.RemoveMenu('App Manager');
        UNAS.RemoveAppFromGroups('App Manager', 'Help');
        UNAS.RemoveAppFromApps('App Manager');
    };
    new UNAS.Menu('UNAS_App_Accessories_Menu', this.name, this.menuIcon, 'App Manager', '', this.AppManagerAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'App Manager', this.AppManagerAppWindow);
    //new UNAS.RegisterToAppGroup(this.name, 'Help', { 'Type': 'AppManager', 'Location': 1, 'Icon': this.shortcutIcon, 'Url': this.entryHelpUrl }, {});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('App Manager', UNAS._('App Manager')); //translate menu
        UNAS.SetShortcutTitle('App Manager', UNAS._('App Manager')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('AppManagerAppWindow', UNAS._('App Manager'));
        }
    };
    UNAS.LoadTranslation('/apps/appmanager/languages/Translation?v=' + this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.AppManagerAppWindow, this.AppManagerUninstall);
};

new AppManagerApp.App();
