var appInfos = [];
var allappinfo = [];
var appAssort = {};
var appListViewModel = 'item';
var progress_timeout = 0;
var appnamelist = {};
var cou = 0;
var upgradTotal = 0;
var curtype = 'all';
var appStepCodeMsg = {
  30: 'System idle',
  42: 'Checking system...',
  50: 'Cleaning up redundant configs...',
  60: 'waiting...',
  99: 'Mission accomplished...'
}
var appExecCodeMsg = {
  0: 'waiting...',
  11: 'executing...',
  15: 'execution failed',
  20: 'execution succeeded'
}

function getappname(applist, packagename) {
  var appname = '';
  for (var v in applist) {
    if (applist.hasOwnProperty(v)) {
      if (applist[v].packagename == packagename) {
        appname = v;
        break;
      }
    }
  }
  return appname;
}

function restartSystem() {
  var rebootWindow = new MUI.Modal({
    id: 'RebootAppWindow',
    title: UNAS._('System Update'),
    contentURL: '/apps/appmanager/reboot.html?v=6.0.62&update=1',
    loadMethod: 'xhr',
    type: 'modal2',
    width: 550,
    height: 250
  });
}

function loadAppList() {
  // appmanagerShowWaiting();
  upgradTotal = 0;
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      dataType: 'json',
      contentType: "application/json;charset=utf-8",
      data: JSON.encode({
        cmd: 'apps_getall',
        token: UToken
      }),
      timeout: 30000,
      success: function(data) {
        if (data.err == 0) {
          if (Array.isArray(data.results.apps)) {
            appInfos = data.results.apps[0].AppsInfo || [];
            allappinfo = data.results.apps[0].AppsInfo || [];
          }else {
            var apps = data.results.apps || {};
            var appsInfo = [];
            for (var v in apps) {
              if (apps.hasOwnProperty(v)) {
                appsInfo.push(apps[v]);
              }
            }
            appInfos = appsInfo;
            allappinfo = appsInfo;
          }

          setappstate(appInfos);

          for (var i = 0; i < appInfos.length; i++) {
            var appdata = appInfos[i];
            var translation = appdata.translation;
            if (+appInfos[i].upgradable) {
              upgradTotal++;
            }
            appnamelist[appInfos[i].appname] = appInfos[i];

            for (var k = 0; k < translation.length; k++) {
              var ts = translation[k];
              if (UNAS.SupportedLanguages.indexOf(ts.language) < 0) UNAS.SupportedLanguages.push(ts.language);
              var tmp = ts.table;
              for (var j = 0; j < tmp.length; j++) {
                var EnglishText = JSON.stringify(tmp[j][0]).slice(1, -1); //original English Text
                var tid = JSON.stringify(tmp[j][1]).slice(1, -1); //text id
                var TranslatedText = JSON.stringify(tmp[j][2]).slice(1, -1);
                UNAS.TranslationTable[JSON.stringify(EnglishText + ts.language + tid)] = TranslatedText; //use property rather than array to save the translations! [English -->Lang]
                UNAS.TranslationTable[JSON.stringify(TranslatedText + 'English' + tid)] = EnglishText; //use property rather than array to save the translations! [Tanslated -->English]
              }
            }
          }

          initAppGallery(AppsObjModeSort(jQuery(".asOrDescending.actived")[0].id,
            jQuery(".sortModeType.actived")[0].id,
            appAssort[curtype]
          ));

          resolve(data);



          if (data.results.catalog) {
            var upgradables = data.results.catalog.upgradables || 0;
            if (upgradables) {
              jQuery("#jv-upgrad-total").html(upgradables).show();
            } else {
              jQuery("#jv-upgrad-total").hide();
            }
          } else {
            if (upgradTotal) {
              jQuery("#jv-upgrad-total").html(upgradTotal).show();
            } else {
              jQuery("#jv-upgrad-total").hide();
            }
          }

          appmanagerHideWaiting();
        } else {
          if (data.err == 9971) {
            jQuery('#jv-onLine').show();
            jQuery("#appmanager_appslist").hide();
          }
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        console.log('TODO: error while loading app list.');
        reject(XMLHttpRequest);
        if (textStatus == 'timeout') {
          jQuery('#jv-onLine').show();
          jQuery("#appmanager_appslist").hide();
        }
      },
      complete: function() {

      }
    });
  })
}

function setappstate(apps) {
  appAssort = {
    'all': [],
    'installed': [],
    'not installed': [],
    'upgradable': [],
    'System': [],
    'Accessories': [],
    'Games': [],
    'Graph': [],
    'Internet': [],
    'Office': [],
    'MultiMedia': [],
    'SystemTools': [],
    'Universal': [],
    'Other': []
  }

  appAssort.all = apps;
  for (var i = 0; i < apps.length; i++) {
    var appdata = apps[i];

    if (appdata.installed) {
      appAssort.installed.push(appdata);
    } else {
      appAssort['not installed'].push(appdata);
    }
    if (appdata.upgradable) {
      appAssort.upgradable.push(appdata);
    }
    if (appdata.section == "Network" || appdata.section == "Storage" || appdata.section == "Account" ||
      appdata.section == "Setting" || appdata.section == "Information") {
      appAssort.System.push(appdata);
    }

    if (appdata.section == 'Accessories') {
      appAssort.Accessories.push(appdata);
    }
    if (appdata.section == 'Games') {
      appAssort.Games.push(appdata);
    }
    if (appdata.section == 'Graph') {
      appAssort.Graph.push(appdata);
    }
    if (appdata.section == 'Internet') {
      appAssort.Internet.push(appdata);
    }
    if (appdata.section == 'Office') {
      appAssort.Office.push(appdata);
    }
    if (appdata.section == 'MultiMedia') {
      appAssort.MultiMedia.push(appdata);
    }
    if (appdata.section == 'SystemTools') {
      appAssort.SystemTools.push(appdata);
    }
    if (appdata.section == 'Universal') {
      appAssort.Universal.push(appdata);
    }
  }

}
//显示app列表
function initAppGallery(appList, fn) {
  if (appList.length === 0) {
    jQuery("#appmanager_appslist").hide();
    jQuery('#jv-nullData').show();
  } else {
    jQuery('#jv-nullData').hide();
    jQuery("#appmanager_appslist").show();
    var exhibits = '';
    var appListDom = '';
    for (var i = 0; i < appList.length; i++) {
      exhibits += initBooth(appList[i]);
    }
    jQuery('#appmanager_appslist').html('');
    if (appListViewModel === 'item') {
      appListDom = '<div class="applistdom" style="margin-left:20px;min-height:300px;padding-bottom:40px;">' + exhibits + '</div>';
    } else if (appListViewModel === 'line') {
      appListDom = '<table class="applistdom unas_table_content"><tbody class="linetype">' + exhibits + '</tbody></table>';
    }

    jQuery('#appmanager_appslist').html(appListDom);

    loadimg(appListViewModel === 'item' ? '.applistdom' : '.linetype');

    appPageTranslator('appmanager_appslist');

  }
  if (typeof fn == 'function') {
    fn();
  }
}

function loadimg(t) {
  jQuery('#appmanager_appslist').find(t).children().each(function(i, e) {
    var url = jQuery(e).find('.imgload').attr('data-url');
    jQuery(e).find('.imgload').attr('src', url).load(function(e) {})
  })
}

// app列表样式
function initBooth(app) {
  var exhibit = '';
  if (appListViewModel === 'item') {
    exhibit += '<div class="apps_items ' + app.packagename + '" id="app_item_' + app.packagename + '" title="' + app.appname + '" appname="' + app.appname + '" packagename="' + app.packagename + '" onclick="appManagerShowDetail();">';
    if (app.upgradable == undefined) {
      app.upgradable = 0;
    }
    var action = app.installed === 0 ? 'noinstall' : (app.upgradable === 0 ? 'installed' : 'update');
    exhibit += '<div class="apps_bj">' +
      '<div class="notice_icon_close">' +
      '<div class="notice_icon_close_text">' +
      '<span class="jvc-notice-text"></span>' +
      '<img src="/apps/appmanager/images/notice_icon_close.png?v=6.0.62&">' +
      '</div>' +
      '</div>' +
      '<img class="appstaimg" src="/apps/appmanager/images/app_bg_' + action + '.png?v=6.0.62">' +
      '</div>' +
      '<div class="apps_section"><span>' + app.section + '</span></div>' +
      '<div class="apps_icon"><img class="imgload" data-url="' + app.icon + '" src="/apps/appmanager/images/img_loading?v=6.0.62"/></div>' +
      '<div class="app_icon_download"><img src="/apps/appmanager/images/app_icon_download.png?v=6.0.62&"> ' + (app.downloads || 1) + '</div>' +
      '<div class="apps_appname"><span>' + app.appname + '</span></div>' +
      '<div class="apps_operate_info">' +
      '<div class="apps_operate_status">Status</div>' +
      '<div class="percent_container">' +
      '<div class="percent_bar_outter">' +
      '<div class="percent_bar_inner" style="width: 0;">' +
      '<div class="percent_bar" style="width: 227px;"></div>' +
      '</div>' +
      '</div>' +
      '<div class="percent_txt" style="display: flex;"></div>' +
      '</div>' +
      '</div>' +
      '<div class="retry" style="display:none;"><span type="btn" class="retrybtn">Retry</span></div>' +
      '<div class="apps_actions">' +
      '<div class="apps_buttons apps_buttons_' + action + '">';

    action = app.installed === 0 ? 'Install' : (app.upgradable === 0 ? 'Open' : 'Upgrade');

    var isshowopen = 0,
      isinstall = 0,
      isupgradable = 0;
    if (app.installed && !app.upgradable) {
      isshowopen = 1;
      isinstall = 0;
      isupgradable = 0;
    } else if (app.installed && app.upgradable) {
      isupgradable = 1;
      isshowopen = 1;
      isinstall = 0;
    } else if (!app.installed) {
      isinstall = 1;
      isshowopen = 0;
      isupgradable = 0;
    }

    exhibit += '<span  class="Upgradebtn" onclick="appActionClicked(\'upgrade\');" style="display:' + (isupgradable ? 'block' : 'none') + '">Upgrade</span>' +
      '<span class="Installbtn" onclick="appActionClicked(\'install\');" style="display:' + (isinstall ? 'block' : 'none') + '">Install</span>' +
      '<span class="Openbtn" onclick="appActionClicked(\'open\');" style="display:' + (isshowopen ? 'block' : 'none') + '">Open</span>' +
      '<span class="Privilegebtn" onclick="SetupAppAccountPrivilege();" style="display:' + (isshowopen ? 'block' : 'none') + '">Privilege</span>';

    var display = (app.removable === 'YES' && app.installed === 1) ? 'block' : 'none';
    var developer = '<div class="apps_developer"><span>' + app.developer + '</span></div>';

    if (app.packagename == 'network-unas') {
      developer = '<div class="apps_developer"><span>##$@network@$##' + app.developer + '##$@network@$##</span></div>';
    }

    exhibit += '</div>' +
      '</div>' +
      developer +
      '</div>';
  } else {
    exhibit += '<tr name="apps_list" class="apps_item ' + app.packagename + ' appmanager_manager_applist_tr" id="app_item_' + app.packagename + '" appname="' + app.appname + '" packagename="' + app.packagename + '">' +
      '<td width="40%" align="left" title="' + app.appname + '" apppkgname="' + app.packagename + '" appname="' + app.appname + '" onclick="appManagerShowDetail(1);">' +
      '<span ><img apppkgname="' + app.packagename + '" class="imgload appmanager_manager_logo" data-url="' + app.icon + '" src="/apps/appmanager/images/img_loading?v=6.0.62"></span>' +
      '<div class="appmanager_manager_listname">' +
      '<div class="appmanager_manager_listnametext">' +
      '<span title="' + app.appname + '">' + app.appname + '</span>' +
      '<div class="notice_icon_close">' +
      '<div class="notice_icon_close_text">' +
      '<span class="jvc-notice-text"></span>' +
      '<img onclick="closeNotice();" src="../apps/appmanager/images/notice_icon_close.png?v=6.0.62&">' +
      '</div>' +
      '</div>' +
      '</div>' +
      '<div class="appmanager_manager_listnametext"><span title="' + app.developer + '">' + app.developer + '</span></div>' +
      '</div>' +
      '</td>' +
      '<td width="15%" align="left" title="' + app.appname + '" onclick="appManagerShowDetail(1);">' +
      '<div class="appmanager_manager_listnametext litext"><span title="' + app.section + '">' + app.section + '</span></div>' +
      '</td>' +
      '<td width="15%" onclick="appManagerShowDetail(1);"><div class="app_icon_download">' +
      '<img src="../apps/appmanager/images/app_icon_download.png?v=6.0.62&"> ' + (app.downloads || 1) +
      ' </div></td>' +
      '<td width="30%" align="right" class="apps_actionsTD">' +
      '<div class="retry" style="display:none;"><span type="btn" class="tdbtn retrybtn">Retry</span></div>' +
      '<div class="apps_operate_info">' +
      '<div class="apps_operate_status">Status</div>' +
      '<div class="percent_container">' +
      '<div class="percent_bar_outter"><div class="percent_bar_inner"><div class="percent_bar"></div></div></div><div class="percent_txt"></div>' +
      '</div>' +
      '</div>';

    var action = app.installed === 0 ? 'Install' : (app.upgradable === 0 ? 'Open' : 'Upgrade');
    var classs = app.installed === 0 ? 'noinstall' : (app.upgradable === 0 ? 'installed' : 'update');
    exhibit += '<div class="apps_actions" style="width:150px">' +
      '<div class="apps_buttons apps_buttons_' + classs + '">' +
      '<span class="tdbtn ' + action + 'btn" title="' + action + 'APP" type="btn" onclick="appActionClicked(\'' + action.toLowerCase() + '\');">' + action + '</span>' +
      '<div class="gd" title="More" onclick="showShortcutMenu();">' +
      '<div class="apps_alertModle" style="display: none;">' +
      '<div class="apps_privilegeSet" onclick="SetupAppAccountPrivilege();"><span>Privilege</span></div>' +
      '<div class="apps_detailsShow" onclick="appManagerShowDetail(1);"><span>Details</span></div>' +
      '<div class="apps_detailsShow" onclick="appActionClicked(\'open\');" style="display:' + (app.installed === 0 ? 'none' : 'block') + '">' +
      '<span>Open</span>' +
      '</div>';

    var display = (app.removable === 'YES' && app.installed === 1) ? 'block' : 'none';
    exhibit += '<div class="app_remove" onclick="appActionClicked(\'remove\');" style="display: ' + display + '">' +
      '<span>##$@appmanager@$##Remove##$@appmanager@$##</span>' +
      '</div>' +
      '</div>' +
      '</div>' +
      '</div>' +
      '</div>' +
      '</td>' +
      '</tr>';
  }

  return exhibit;
}

// 显示加载动画
function appmanagerShowWaiting() {
  jQuery('#appmanager_manager_waiting_content').show();
  jQuery('#appmanager_manager_waiting_logo').show();
}

// 隐藏加载动画
function appmanagerHideWaiting() {
  jQuery('#appmanager_manager_waiting_content').hide();
  jQuery('#appmanager_manager_waiting_logo').hide();
}

function getAppmanagerText(txt) {
  return '##$@appmanager@$##' + txt + '##$@appmanager@$##';
}

function callAppUninstallFunc(appname) {
  for (var i = 0; i < UNAS.Apps.length; i++) {
    if (appname == UNAS.Apps[i].appName) {
      if (UNAS.Apps[i].appUninstallFunc) {
        UNAS.Apps[i].appUninstallFunc();
      }
      break;
    }
  }
}

jQuery(document).click(function() {
  jQuery(".apps_alertModle").css("display", "none");
});

// 升/降序函数
function AppsObjModeSort(_t, _ss, data) {
  if (_ss == "size") {
    for (var i = 0; i < appInfos.length; i++) {
      if (isNaN(appInfos[i].size)) {
        var unit = appInfos[i].size.replace(parseFloat(appInfos[i].size), "");
        if (unit == "M") {
          appInfos[i].size = parseFloat(appInfos[i].size) * 1024;
        } else {
          appInfos[i].size = parseFloat(appInfos[i].size);
        }
      }
    }
  }
  if (data._ss != '' && isNaN(data._ss)) {
    if (_t == "ascending") { //升序
      data.sort(function(a, b) {
        var val1 = a[_ss];
        var val2 = b[_ss];
        //升序
        if (val1 < val2) {
          return -1;
        } else if (val1 > val2) {
          return 1;
        } else {
          return 0;
        }
      });
    } else if (_t == "descending") {
      data.sort(function(a, b) { //降序
        var val1 = a[_ss];
        var val2 = b[_ss];
        //降序
        if (val2 < val1) {
          return -1;
        } else if (val2 > val1) {
          return 1;
        } else {
          return 0;
        }
      });
    }
  }
  return data;
}

(function() {
  //隐藏模板
  window.wfOnDocumentReady = function() {
    jQuery('#jvt-templates').hide();
  };
  //克隆模板
  window.wfTemplateAppend = function(target, template, name) {
    jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
    var tagName = '#' + name;
    return jQuery(tagName);
  };
})()

//删除数组中相同对象
function removeArrIdenticalObj(_arr, _obj, type) {
  var length = _arr.length;

  for (var i = 0; i < length; i++) {
    if (isObjectValueEqual(_arr[i], _obj) || _arr[i][type] == _obj[type]) {
      if (i == 0) {
        _arr.shift(); //删除并返回数组的第一个元素
        return _arr;
      } else if (i == length - 1) {
        _arr.pop(); //删除并返回数组的最后一个元素
        return _arr;
      } else {
        _arr.splice(i, 1); //删除下标为i的元素
        return _arr;
      }
    }
  }

};

//  判断数组中对象是否相等
function isObjectValueEqual(a, b) {
  if (typeof(a) != "object" && typeof(b) != "object") {
    if (a == b) {
      return true;
    } else {
      return false;
    }
  }
  var aProps = Object.getOwnPropertyNames(a);
  var bProps = Object.getOwnPropertyNames(b);

  if (aProps.length != bProps.length) {
    return false;
  }

  for (var i = 0; i < aProps.length; i++) {
    var propName = aProps[i];

    if (a[propName] !== b[propName]) {
      return false;
    }
  }

  return true;
}
